/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks of the Open-Xchange, Inc. group of companies.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2004-2010 Open-Xchange, Inc.
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
package com.openexchange.usm.syncml;

public interface SyncMLBundleErrorCodes {

	int INVALID_ALIAS_FOR_SERVLET = 0x620000;
	int SERVLET_REGISTRATION_FAILED = 0x620001;
	int SERVLET_ALIAS_IN_USE = 0x620002;
	int UTF8_NOT_SUPPORTED = 0x620003;
	int INITIALIZER_USM_SYNCML_ACCESS_DENIED_FOR_USER = 0x620004;
	int DEVICE_INFO_COULD_NOT_BE_RETRIEVED = 0x620005;
	int REQUIRED_CONTENTTYPE_NOT_AVAILABLE = 0x620006;
	int MISSING_LOG_FILE = 0x620007;
	int INVALID_SYNC_TIMEOUT = 0x620008;
	int INVALID_FORMATTED_SERVER_ANCHORS = 0x620009;
	int INVALID_DEFAULT_MAX_MESSAGE_SIZE = 0x62000A;
	int INVALID_SYNC_ALL_FOLDERS = 0x62000B;
	int INVALID_REDIRECT_URLS = 0x62000C;
	int INVALID_DEBUG_LOGFILE = 0x62000D;

	int REQUEST_BAD_XML = 0x620100;
	int REQUEST_IO_ERROR = 0x620101;

	int CAN_NOT_EXECUTE_ADD_COMMAND = 0x620200;
	int CAN_NOT_EXECUTE_COPY_COMMAND = 0x620201;
	int CAN_NOT_EXECUTE_DELETE_COMMAND = 0x620202;
	int CAN_NOT_EXECUTE_GET_COMMAND = 0x620203;
	int CAN_NOT_EXECUTE_REPLACE_COMMAND = 0x620204;
	int CAN_NOT_EXECUTE_SEQUENCE_COMMAND = 0x620205;
	int COMMAND_NOT_IMPLEMENTED = 0x620206;

	int ALERT_FAILED_FOR_FOLDER = 0x620300;
	int COMMAND_MULTIPLE_ACTIONS_ON_DATA_OBJECT = 0x620301;

	int MAP_FAILED_FOR_FOLDER = 0x620400;

	// 0x628000-62ffff reserved for content type mapping errors, (0x62AABB, where AA specifies mapping, BB is internal error number in a mapping)

	int VCARD_CONTENT_TYPE_MISMATCH = 0x628000;
	int VCARD_FIELD_PARSING_FAILED = 0x628001;

}
